#!/usr/bin/python3  
# Questionaire_mate.py    Author: Mark Osborne
#  
# This reads in a list of questions and uses OpenAI to answer them based on a private knowledge base 
# Designed to answer 3rd party questionaires
#  
# 1 - read/upload a knowledge base and a questionaire
# 2 -  create an assistant object
# 3 -  Create an Execution Thread
# 4 - loop round  all questions in the questionaire 
# 4a - send  a Message to the Thread with a question in it
# 4b -  Run the Assistant request
# 49c - loop waiting for the request to complete 
# 4d - print the output 
# 5 - clean up 
#
#
#       output written  to output.txt
#
#
import os
import openai
import time
import datetime
import re
c = chr(0x3011)
cc= c + "\."


def read_file_to_array():
    file_path = input("Enter the file name of the Questionaire: \n")
    try:
        with open(file_path, 'r') as file:
            lines = file.readlines()
            # Remove any trailing newline characters
            lines = [line.strip() for line in lines]
        return lines
    except FileNotFoundError:
        print(f"The file at {file_path} was not found.")
        exit(1)
        return []

def create_file_object():          
  while True: 
     ansfile = input("Enter the file name of the knowledge base : \n")  
     if os.path.exists(ansfile):
        return([ansfile])


        
def  wait_run_complete( wait_thread_id, wait_run_id) :
#  Periodically retrieve the Run to check on its status to see if it has moved to completed
  err_count = 0
  keep_retrieving_run = openai.beta.threads.runs.retrieve( thread_id= wait_thread_id, run_id= wait_run_id)
  dot="."
  while True: 
  # while keep_retrieving_run.status in ["queued", "in_progress"]:
      keep_retrieving_run = openai.beta.threads.runs.retrieve( thread_id= wait_thread_id, run_id= wait_run_id)
      print(f"!Run status: {keep_retrieving_run.status} {dot}",end="\r")
      dot+="."
      if keep_retrieving_run.status == "completed":
        print("\n********complete******                         \n")
        return( keep_retrieving_run.status )              
      elif keep_retrieving_run.status == "queued" or keep_retrieving_run.status == "in_progress":
        time.sleep(14)
        pass
      else:
        print(f"Run status: {keep_retrieving_run.status}                                 ")
        return("failed")

# def  clean_up( my_assistant, my_file) :
def  clean_up( vs_id , my_file) :
  try:
    vs  = openai.beta.vector_stores.delete(vs_id)
    print(f"successful delete of vect resource object: {vs} \n")
  except : 
    print(f"del vector store  error    \n")
  try:
    del_file=openai.files.delete(my_file.id)
    print(f"delete file success: file object: {del_file} \n")
  except : 
    print(f"del file error    \n")


debug = True
debug = False
QUEST_LIMIT = 40 ## openai seems to get tired after 40 or so questions -- if it does for you set 1000



openai.api_key =  os.getenv('OPENAI_API_KEY')
if debug :
  print( openai.api_key )
# Example usage
file_path = 'output.txt'

file = open(file_path, 'w') 
text = f"Questionnaire_mate - Question and Answer AI completion system \n \n \n"
file.write(text)
print(text)
print("Questionnaire_mate is a system that can answer 3rd party security governance questionnaires\n")

print("Tip: run a Questionnaire through the system several times to improve results \n")

print("Tip: a soft limit is set 40 so split large questionaires up using unix slplit command \n or alter constant QUEST_LIMIT \n\n")



# read in a list of questions
def main():
  rollover=False
  reuse = ""
  score = []
  vsfile_path = "./vector_store_id" 

  questionaire  = read_file_to_array()
  if debug :
    print( questionaire )


  vector_store_ids = False 
  if os.path.exists(vsfile_path):
     print("Existing vector store found! if you want to use it type 'reuse' - if you want to start from scratch type 'scratch'\n")
     reuse =  "[ENTER]\n"
     try:
           vsidfile = open(vsfile_path,'r') 
           vector_store_ids = vsidfile.readline().strip()
           print(f"Vector store id: {vector_store_ids} \n" )
           text = f"Vector store id: {vector_store_ids} \n" 
           file.write(text)
           vector_store_date = vsidfile.readline().strip()
           text = f"Vector store was saved on {vector_store_date} \n" 
           print(text) 
           file.write(text)
           vector_store_basefile = vsidfile.readline().strip()
           text=f"Vector store was based on: { vector_store_basefile } \n" 
           print(text) 
           file.write(text)
           vsidfile.close()
           while reuse not in ['reuse', 'scratch'] :
             reuse = input("Enter 'reuse' or 'scratch' \n")
             if debug :
                print(f' input value {reuse} \n')
     except : 
           print(f"vs  file error    \n")
           exit()
  
  if reuse == 'scratch'  :
     file_paths = create_file_object()          
     if debug :
        print(f" Process knowledge file:  {file_paths}  \n") 
  
     file_streams = [open(path, 'rb') for path in file_paths]
#   Create a vector store called knowledgebase
     vector_store = openai.beta.vector_stores.create(name="knowledgebase")
# Use the upload and poll SDK helper to upload the files, add them to the vector store,
# and poll the status of the file batch for completion.
     file_batch = openai.beta.vector_stores.file_batches.upload_and_poll(
        vector_store_id=vector_store.id, files=file_streams) 
     vector_store_ids = vector_store.id

# You can print the status and the file counts of the batch to see the result of this operation.
     print(f'file batch status: {file_batch.status}' )
     print(f' file counts: {file_batch.file_counts} \n' )
     time.sleep(20)
#  Create an Assistant
  print(f"vector store id: {vector_store_ids} \n" )
  my_assistant = openai.beta.assistants.create(
   # model="gpt-3.5-turbo-1106",
    model="gpt-4o",
    instructions="""You are an administrator answering questions  found in a reference document containing the only correct answers.
    You need to select the best answer from the document upload.
    Provide 1 answer that matches the intent of the question from the best line in  the vector store, with all the detail provided . Do not combine multiple answers from .
    Do not provide answers not contained  in the file. 
    If the answer is not found in the file answer  'I DONT KNOW'.

    """,
    name="leme", temperature=0.0,
    tools=[{"type": "file_search"}],
  #  tool_resources={ "file_search": { "vector_stores": [{ "file_ids": [ my_file.id] }] } } )
    tool_resources={ "file_search": { "vector_store_ids": [vector_store_ids]}})
 #
  if debug :
    print(f"This is the assistant object: {my_assistant} \n")

# Create a Thread
  my_thread = openai.beta.threads.create()
  if debug :
    print(f"This is the thread object: {my_thread} \n")
#process a single question from  the questionaire
  for question in questionaire :
#   performance degregates after 40 questions so we recommend splitting questionnaire 
#   into mutltiple runs
    if  len(score) > QUEST_LIMIT:
       print("Run limit hit, exiting  - recommend splitting questionnaire \n\n\n" )
       break

    time.sleep(8) 
  #  print( question )
  #  send   a Message to a Thread
    my_thread_message = openai.beta.threads.messages.create(
      thread_id=my_thread.id,
      role="user",
      content=question 
#      attachments=[{"file_id": my_file.id , "tools": [{"type": "file_search"}]}]
#  attachments=[{"file_id": my_file.id , "tools": [{"type": "file_search"}]}]
      ) 

    if debug :
      print(f"This is the message object: {my_thread_message} \n")

#  Run the Assistant request
    my_run = openai.beta.threads.runs.create( thread_id=my_thread.id, assistant_id=my_assistant.id, instructions="Please ")
    if debug :
      print(f"This is the run object: {my_run} \n")

# Wait checking the Run status to see if it has moved to completed
    wait_state = wait_run_complete( 
        my_thread.id,
        my_run.id
        )
        
    print(f" Question id : {my_thread_message.id} \n")
    if wait_state == "completed":
      score.append("completed")
    else:
      score.append("failed")
#  Retrieve the Messages added by the Assistant to the Thread
    all_messages = openai.beta.threads.messages.list(
          thread_id=my_thread.id)
    text_kludge = f": {all_messages.data[0].content[0].text.value} \n\n"
#
#     kudge-start
#     kudge to compensate for faulty message polling
#     often a call fails but a subsequent call contains the answer for a previous question 
#     here we check for two citations and split if there is more than 2
#     suggesting the first is the postponed answer
    if  rollover == True :
        aa = f"RE-Answer: {all_messages.data[0].content[0].text.value}"
        rollover=False
        if aa.count(c) >= 2 :
           bb = re.split(cc,aa)
           print(bb[0])
           text_kludge =  bb[1:]

    if my_thread_message.content[0].text.value == all_messages.data[0].content[0].text.value :
        print("Suspected polling issue - check for answer in subsquent listing\n")
        text=f"Suspected polling issue - check for answer in subsquent listing\n"
        file.write(text)
        rollover=True
#     kudge-end
#
        
    print("------------------------------------------------------------ \n")
    print(f"Question: {my_thread_message.content[0].text.value} \n\n")
    # experimental testing the citation to confirm answer was drawn from knowledge base
    # approach fails because extropolate answers i.e do you have a security policy answer yes or no
    # do not refer to the source citation of the interpolation
    # print(f"query : {all_messages.data[0].content[0].text.annotations}")
    print(f"answer: {my_thread_message.id} \n\n")
    text = f"Question: {my_thread_message.content[0].text.value} \n\n"
    file.write(text)
    text=f"Answer: {text_kludge}"
    print(text)
    file.write(text_kludge)
### end loop

  print(f"tool resource object: {my_assistant.tool_resources.file_search.vector_store_ids} \n")
  # clean_up( my_assistant, my_file) 

  if reuse != "reuse":
     print("Storing new vector_store_id for later use \n")
     vsidfile = open("./vector_store_id", 'w') 
     vsidfile.write (my_assistant.tool_resources.file_search.vector_store_ids[0])
     text = f"\nDatetime: {datetime.datetime.now()} \n"
     print(text)
     vsidfile.write(text)
     text = f"Questionnaire name: {file_paths} \n"
     print(text)
     vsidfile.write(text)
     vsidfile.close
  else:
     print("Vector_store_id retained for later use \n")


  print(f"     \t Summary Report          \n")
  print(f" Ref \t score     \t  questionaire  \n")

  for x in range(len(score)) :
     print(f" {x+1} \t {score[x]} \t  {questionaire[x]}  \n")

  my_assistant_id = my_assistant.id 
  my_assistant = openai.beta.assistants.delete( my_assistant_id )
  print(f"This is the assistant object: {my_assistant} \n")
## end main
## end main
## end main


if __name__ == "__main__":
    main()
